<?php
/**
 * Clase Base FN para BaseArArqueoDetalleDepositoFN
 *
 * @package    
 * @subpackage BaseArArqueoDetalleDepositoFN
 * @author     Willy
 * @version    SVN:: BaseArArqueoDetalleDepositoFN.class.php,v 1.1 2020-07-01 22:10:05 william.taype Exp $
 */
class BaseArArqueoDetalleDepositoFN extends ArArqueoDetalleDepositoBN
{
	
	public $a_Condition = array();
	public $a_OrderBy = array();
	
  private static $fieldNames = array (
    'Idclase'=>'idclase', 'Idsucursal'=>'idsucursal', 'Idmercado'=>'idmercado', 'Idcolaborador'=>'idcolaborador', 'Fecha'=>'fecha', 'Idcliente'=>'idcliente', 'Idprestamo'=>'idprestamo', 'Nombrecliente'=>'nombrecliente', 'Idbanco'=>'idbanco', 'Idcuenta'=>'idcuenta', 'Banco'=>'banco', 'Numerocuenta'=>'numerocuenta', 'Fechadeposito'=>'fechadeposito', 'Numeroboucher'=>'numeroboucher', 'Subtotal'=>'subtotal', 'Estado'=>'estado', 'Idpagoreferencia'=>'idpagoreferencia', 'Fecharegistro'=>'fecharegistro', 'Usuarioregistro'=>'usuarioregistro'  
  );

public function getSelectColumns()
{
	$s_SQLQuery = "idclase AS idclase, ";
	$s_SQLQuery .= "idsucursal AS idsucursal, ";
	$s_SQLQuery .= "idmercado AS idmercado, ";
	$s_SQLQuery .= "idcolaborador AS idcolaborador, ";
	$s_SQLQuery .= "fecha AS fecha, ";
	$s_SQLQuery .= "idcliente AS idcliente, ";
	$s_SQLQuery .= "idprestamo AS idprestamo, ";
	$s_SQLQuery .= "nombrecliente AS nombrecliente, ";
	$s_SQLQuery .= "idbanco AS idbanco, ";
	$s_SQLQuery .= "idcuenta AS idcuenta, ";
	$s_SQLQuery .= "banco AS banco, ";
	$s_SQLQuery .= "numerocuenta AS numerocuenta, ";
	$s_SQLQuery .= "fechadeposito AS fechadeposito, ";
	$s_SQLQuery .= "numeroboucher AS numeroboucher, ";
	$s_SQLQuery .= "nombrearchivo AS nombrearchivo, ";
	$s_SQLQuery .= "subtotal AS subtotal, ";
	$s_SQLQuery .= "estado AS estado, ";
	$s_SQLQuery .= "comentario AS comentario, ";
	$s_SQLQuery .= "idpagoreferencia AS idpagoreferencia, ";
	$s_SQLQuery .= "fecharegistro AS fecharegistro, ";
	$s_SQLQuery .= "usuarioregistro AS usuarioregistro ";
	return $s_SQLQuery;
}

 public function getConnect()
    {
    	
        //$o_DBConnect = Conexion2::getConexion($this->i_reconectar);
        //$o_Resource = $o_DBConnect->getResource();
            $o_DBConnect = Conexion2::getConexion();
			$o_Resource = $o_DBConnect->getResource();
			return $o_Resource;
         //$result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
    
        return $o_Resource;
    }

 public function select2()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, idcliente, idprestamo, nombrecliente, idbanco, idcuenta, banco, numerocuenta, fechadeposito, numeroboucher, subtotal, estado, comentario, nombrearchivo, idpagoreferencia, fecharegistro, usuarioregistro FROM ar_arqueo_detalle_deposito WHERE ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
	  //echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function select( $i_Position = null, $i_Rows = null )
  {
    /* try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, idcliente, idprestamo, nombrecliente, idbanco, idcuenta, banco, numerocuenta, fechadeposito, numeroboucher, subtotal, estado,nombrearchivo, idpagoreferencia, fecharegistro, usuarioregistro FROM ar_arqueo_detalle_deposito WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    } */
	$s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM ar_arqueo_detalle_deposito WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        if ( count( $this->a_OrderBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."ORDER BY ";
            $s_Separator = "";
            foreach ( $this->a_OrderBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                if ( $a_OrderBy[ "ASC" ] === false ) $s_SQLQuery .= "DESC ";
                $s_Separator = ", ";
            }
        }
        if( !is_null( $i_Position ) && is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position;
        if( !is_null( $i_Position ) && !is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position.", ".$i_Rows;
        $s_SQLQuery .= ";";

        $a_Cr_pedido_prestamoBN = null;
        $o_Resource = $this->getConnect();
        //echo $s_SQLQuery."";
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        while ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $o_Cr_pedido_prestamoBN = $this->insertObjectBN( $a_SQLRow );
            $a_Cr_pedido_prestamoBN[] = $o_Cr_pedido_prestamoBN;
        }
        return $a_Cr_pedido_prestamoBN;
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, idcliente, idprestamo, nombrecliente, idbanco, idcuenta, banco, numerocuenta, fechadeposito, numeroboucher, subtotal, estado, comentario, idpagoreferencia, fecharegistro, usuarioregistro FROM ar_arqueo_detalle_deposito WHERE  ".$where;
      //echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

	public function addCondition( $s_Const, $s_Operator, $u_Value,$b_ComSimple=true )
	{
		$this->a_Condition[] = array( "COLUMN" => $s_Const, "OPERATOR" => $s_Operator, "VALUE" => $u_Value );
	}

	public function addOrderBy( $s_Const, $b_OrderAsc = true )
	{
		$this->a_OrderBy[] = array( "COLUMN" => $s_Const, "ASC" => $b_OrderAsc );
	}

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdclase()){ $where .= " idclase = '".$this->getIdclase()."' AND "; }
      if($this->getIdsucursal()){ $where .= " idsucursal = ".$this->getIdsucursal()." AND "; }
      if($this->getIdmercado()){ $where .= " idmercado = ".$this->getIdmercado()." AND "; }
      if($this->getIdcolaborador()){ $where .= " idcolaborador = ".$this->getIdcolaborador()." AND "; }
      if($this->getFecha()){ $where .= " fecha = '".$this->getFecha()."' AND "; }
      if($this->getIdcliente()){ $where .= " idcliente = ".$this->getIdcliente()." AND "; }
      if($this->getIdprestamo()){ $where .= " idprestamo = ".$this->getIdprestamo()." AND "; }
      if($this->getNombrecliente()){ $where .= " nombrecliente = '".$this->getNombrecliente()."' AND "; }
      if($this->getIdbanco()){ $where .= " idbanco = ".$this->getIdbanco()." AND "; }
      if($this->getIdcuenta()){ $where .= " idcuenta = ".$this->getIdcuenta()." AND "; }
      if($this->getBanco()){ $where .= " banco = '".$this->getBanco()."' AND "; }
      if($this->getNumerocuenta()){ $where .= " numerocuenta = ".$this->getNumerocuenta()." AND "; }
      if($this->getFechadeposito()){ $where .= " fechadeposito >= '".$this->getFechadeposito()."' AND "; }
      if($this->getFechadepositofinal()){ $where .= " fechadeposito <= '".$this->getFechadepositofinal()."' AND "; }
      if($this->getNumeroboucher()){ $where .= " numeroboucher = ".$this->getNumeroboucher()." AND "; }
      if($this->getSubtotal()){ $where .= " subtotal = ".$this->getSubtotal()." AND "; }
      if($this->getEstado()){ $where .= " estado = '".$this->getEstado()."' AND "; }
      if($this->getComentario()){ $where .= " comentario = '".$this->getComentario()."' AND "; }
      if($this->getIdpagoreferencia()){ $where .= " idpagoreferencia = ".$this->getIdpagoreferencia()." AND "; }
      if($this->getFecharegistro()){ $where .= " fecharegistro >= '".$this->getFecharegistro()."' AND "; }
      if($this->getFecharegistrofinal()){ $where .= " fecharegistro <= '".$this->getFecharegistrofinal()."' AND "; }
      if($this->getUsuarioregistro()){ $where .= " usuarioregistro = '".$this->getUsuarioregistro()."' AND "; }
	  //echo $where;
	  if ( count( $this->a_Condition ) > 0 )
        {
            foreach ( $this->a_Condition as $a_Condition )
            {
                 if( $a_Condition['FLAG_COMILLAS'] )
                {
                    $where .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." '".$a_Condition[ "VALUE" ]."' AND ";
                }
                else
                {
                    $where .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." ".$a_Condition[ "VALUE" ]." AND ";
                }
            }
        }
		$where	 .= "1 = 1 ";
	//echo $where;
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Búsqueda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, idcliente, idprestamo, nombrecliente, idbanco, idcuenta, banco, numerocuenta, fechadeposito, numeroboucher, subtotal, estado, comentario, nombrearchivo,idpagoreferencia, fecharegistro, usuarioregistro FROM ar_arqueo_detalle_deposito WHERE 1 AND idclase='".$this->getIdclase()."' AND idsucursal='".$this->getIdsucursal()."' AND idmercado='".$this->getIdmercado()."' AND idcolaborador='".$this->getIdcolaborador()."' AND fecha='".$this->getFecha()."' AND idcliente='".$this->getIdcliente()."' AND idprestamo='".$this->getIdprestamo()."'  AND numeroboucher='".$this->getNumeroboucher()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseArArqueoDetalleDepositoFN = new BaseArArqueoDetalleDepositoFN();
    $o_BaseArArqueoDetalleDepositoFN->setIdclase($o_propel->idclase);
    $o_BaseArArqueoDetalleDepositoFN->setIdsucursal($o_propel->idsucursal);
    $o_BaseArArqueoDetalleDepositoFN->setIdmercado($o_propel->idmercado);
    $o_BaseArArqueoDetalleDepositoFN->setIdcolaborador($o_propel->idcolaborador);
    $o_BaseArArqueoDetalleDepositoFN->setFecha($o_propel->fecha);
    $o_BaseArArqueoDetalleDepositoFN->setIdcliente($o_propel->idcliente);
    $o_BaseArArqueoDetalleDepositoFN->setIdprestamo($o_propel->idprestamo);
    $o_BaseArArqueoDetalleDepositoFN->setNombrecliente($o_propel->nombrecliente);
    $o_BaseArArqueoDetalleDepositoFN->setIdbanco($o_propel->idbanco);
    $o_BaseArArqueoDetalleDepositoFN->setIdcuenta($o_propel->idcuenta);
    $o_BaseArArqueoDetalleDepositoFN->setBanco($o_propel->banco);
    $o_BaseArArqueoDetalleDepositoFN->setNumerocuenta($o_propel->numerocuenta);
    $o_BaseArArqueoDetalleDepositoFN->setFechadeposito($o_propel->fechadeposito);
    $o_BaseArArqueoDetalleDepositoFN->setNumeroboucher($o_propel->numeroboucher);
    $o_BaseArArqueoDetalleDepositoFN->setNombrearchivo($o_propel->nombrearchivo);
    $o_BaseArArqueoDetalleDepositoFN->setSubtotal($o_propel->subtotal);
    $o_BaseArArqueoDetalleDepositoFN->setEstado($o_propel->estado);
    $o_BaseArArqueoDetalleDepositoFN->setComentario($o_propel->comentario);
    $o_BaseArArqueoDetalleDepositoFN->setIdpagoreferencia($o_propel->idpagoreferencia);
    $o_BaseArArqueoDetalleDepositoFN->setFecharegistro($o_propel->fecharegistro);
    $o_BaseArArqueoDetalleDepositoFN->setUsuarioregistro($o_propel->usuarioregistro);
    return $o_BaseArArqueoDetalleDepositoFN;
  }
  
}